package mimic;

import java.util.Random;

/**
 * 
 * This class represents a Tuple of two word [prevWord , currWord]. Each tuple
 * also includes an array with references to other word tuples that follow this
 * tuple.
 * 
 */
public class WordTuple {

	private final String prevWord;
	private final String currWord;
	private WordTuple[] followingWordTuples;
	private int numOfTuples;

	/**
	 * Constructor for the class
	 * 
	 * @pre (prevWord!=null)&&(currWord!=null)
	 * @param prevWord
	 * @param currWord
	 */
	public WordTuple(String prevWord, String currWord) {
		followingWordTuples = new WordTuple[20];
		numOfTuples = 0;
		this.prevWord = prevWord;
		this.currWord = currWord;
	}

	/**
	 * 
	 * @return the previous word from this tuple [prevWord,currWord]
	 */
	public String getPrevWord() {
		/* YOUR CODE GOES HERE */
	}

	/**
	 * 
	 * @return the current word from this tuple [prevWord,currWord]
	 */
	public String getCurrWord() {
		/* YOUR CODE GOES HERE */
	}

	/**
	 * 
	 * @return the number of following tuples.
	 */
	public int getNumOfFollowingTuples() {
		/* YOUR CODE GOES HERE */
	}

	/**
	 * 
	 * @return one of the following word tuples which is randomly chosen between
	 *         all following tuples. If there are no following tuples returns
	 *         'null'.
	 */
	public WordTuple getNextTuple() {
		if (numOfTuples <= 0) {
			return null;
		}

		Random random = new Random();
		int index = random.nextInt(numOfTuples); // return a number between 0
													// and numOfTuples-1
		return followingWordTuples[index];
	}

	/**
	 * 
	 * @param newWord
	 * @return true if there exists a WordTuple followingTuple in
	 *         followingWordTuples such that
	 *         followingTuple.getCurrWord().equals(newWord)), otherwise returns
	 *         false.
	 */
	public boolean followingWordsContain(String newWord) {
		/* YOUR CODE GOES HERE */
	}

	/**
	 * Adds the given tuple to the following tuples array. If the array is full
	 * or if the tuple already exist - nothing will be added.
	 * 
	 * @pre (newWordTuple!=null)
	 * @param newWordTuple
	 */
	public void addFollowingWordTuple(WordTuple newWordTuple) {
		/* YOUR CODE GOES HERE */
	}

}
